package com.ruoyi.yiqi.controller;

import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.annotation.RepeatSubmit;
import com.ruoyi.common.core.controller.BaseController;
//import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.validate.AddGroup;
import com.ruoyi.common.core.validate.EditGroup;
import com.ruoyi.common.core.validate.QueryGroup;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
//import com.ruoyi.gas.domain.bo.GOrderBo;
//import com.ruoyi.gas.domain.vo.GOrderExportVoAnJian;
//import com.ruoyi.gas.domain.vo.GOrderExportVoWeiXiu;
//import com.ruoyi.gas.domain.vo.GOrderVo;
//import com.ruoyi.gas.service.IGAreaService;
//import com.ruoyi.gas.service.IGOrderService;
import com.ruoyi.yiqi.entity.YqGOrder;
import com.ruoyi.yiqi.entity.YqGOrderExportVoAnJian;
import com.ruoyi.yiqi.entity.YqGOrderExportVoWeiXiu;
import com.ruoyi.yiqi.service.IYqGOrderService;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Arrays;
import java.util.List;

/**
 * 工程管理Controller
 *
 * @author ruoyi
 * @date 2021-11-16
 */
@Validated
//@Api(value = "工程管理控制器", tags = {"工程管理管理"})
@RequiredArgsConstructor(onConstructor_ = @Autowired)
@RestController
@RequestMapping("/gas/order")
public class YqGOrderController extends BaseController {

    @Resource
    private final IYqGOrderService iGOrderService;
//    private final YqBackup backup;

//    @Autowired
//    private IYqGAreaService areaService;

    /**
     * 查询工程管理列表
     */
//    @ApiOperation("查询工程管理列表")
//    @PreAuthorize("@ss.hasPermi('gas:order:list')")
    @GetMapping("/list")
    public TableDataInfo<YqGOrder> list(@Validated(QueryGroup.class) YqGOrder bo) {
        return iGOrderService.queryPageList(bo);
    }

    /**
     * 导出工程管理列表
     */
//    @ApiOperation("导出工程管理列表")
//    @PreAuthorize("@ss.hasPermi('gas:order:export')")
    @Log(title = "工程管理", businessType = BusinessType.EXPORT)
    @GetMapping("/export")
    public void export(@Validated YqGOrder bo, HttpServletResponse response) {
        List<YqGOrder> list = iGOrderService.getListExport(bo);
        ExcelUtil.exportExcel(list, "工程管理", YqGOrder.class, response);
    }

    /**
     * 获取工程管理详细信息
     */
//    @ApiOperation("获取工程管理详细信息")
//    @PreAuthorize("@ss.hasPermi('gas:order:query')")
    @GetMapping("/{id}")
    public R<YqGOrder> getInfo(@NotNull(message = "主键不能为空")
                                                  @PathVariable("id") Long id) {
        return R.ok(iGOrderService.getById(id));
    }

    @GetMapping("/getListAll")
    public TableDataInfo<YqGOrder> getListAll(@Validated(QueryGroup.class) YqGOrder bo) {
        return iGOrderService.getListAll(bo);
    }

    /**
     * 工程审核列表查询
     * @param bo
     * @return
     */
    @GetMapping("/getListExamine")
    public TableDataInfo<YqGOrder> getListExamine(@Validated(QueryGroup.class) YqGOrder bo) {
        return iGOrderService.getListExamine(bo);
    }

    /**
     * 管材类别统计
     * @param id
     * @return
     */
    @GetMapping("/getExaminePipeType")
    public R getExaminePipeType(Long id) {
        return R.ok(iGOrderService.getExaminePipeType(id));
    }

    /**
     * 管材长度统计
     * @param id
     * @return
     */
    @GetMapping("/getExaminePipeLength")
    public R getExaminePipeLength(Long id) {
        return R.ok(iGOrderService.getExaminePipeLength(id));
    }

    /**
     * 自闭阀类别统计
     * @param id
     * @return
     */
    @GetMapping("/getExamineValveType")
    public R getExamineValveType(Long id) {
        return R.ok(iGOrderService.getExamineValveType(id));
    }

    @GetMapping("/getOrderForStatus")
    public R getOrderForStatus(Long houseId,String id) {
        return R.ok(iGOrderService.getOrderForStatus(houseId,id));
    }

    /**
     * 统计图点击跳转列表
     * @param bo
     * @return
     */
    @GetMapping("/getListByStatus")
    public TableDataInfo<YqGOrder> getListByStatus(@Validated(QueryGroup.class) YqGOrder bo) {
        return iGOrderService.getListByStatus(bo);
    }
    @GetMapping("/backup")
    public R backup() {
//        backup.getbackup();
        return R.ok();
    }

    /**
     * 安检列表
     * @param bo
     * @return
     */
//    @PreAuthorize("@ss.hasPermi('gas:anjian:query')")
    @GetMapping("/getListAnJian")
    public TableDataInfo<YqGOrder> getListAnJian(@Validated(QueryGroup.class) YqGOrder bo) {
        return iGOrderService.getListAnJian(bo);
    }

    /**
     * 安检导出
     */
//    @ApiOperation("安检导出")
//    @PreAuthorize("@ss.hasPermi('gas:anjian:getListAnJianExport')")
    @Log(title = "安检导出", businessType = BusinessType.EXPORT)
    @GetMapping("/getListAnJianExport")
    public void getListAnJianExport(@Validated YqGOrder bo, HttpServletResponse response) {
        List<YqGOrderExportVoAnJian> list = iGOrderService.getListAnJianExport(bo);
        ExcelUtil.exportExcel(list, "安检导出", YqGOrderExportVoAnJian.class, response);
    }

    /**
     * 维修列表
     * @param bo
     * @return
     */
//    @PreAuthorize("@ss.hasPermi('gas:weixiu:query')")
    @GetMapping("/getListWeiXiu")
    public TableDataInfo<YqGOrder> getListWeiXiu(@Validated(QueryGroup.class) YqGOrder bo) {
        return iGOrderService.getListWeiXiu(bo);
    }

    /**
     * 维修导出
     */
//    @ApiOperation("维修导出")
//    @PreAuthorize("@ss.hasPermi('gas:weixiu:getListWeiXiuExport')")
    @Log(title = "维修导出", businessType = BusinessType.EXPORT)
    @GetMapping("/getListWeiXiuExport")
    public void getListWeiXiuExport(@Validated YqGOrder bo, HttpServletResponse response) {
        List<YqGOrderExportVoWeiXiu> list = iGOrderService.getListWeiXiuExport(bo);
        ExcelUtil.exportExcel(list, "安检导出", YqGOrderExportVoWeiXiu.class, response);
    }

    /**
     * 开栓列表
     * @param bo
     * @return
     */
//    @PreAuthorize("@ss.hasPermi('gas:kaisuan:query')")
    @GetMapping("/getListKaiShuan")
    public TableDataInfo<YqGOrder> getListKaiShuan(@Validated(QueryGroup.class) YqGOrder bo) {
        return iGOrderService.getListKaiShuan(bo);
    }
}
