package com.ruoyi.yiqi.controller;

import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.annotation.RepeatSubmit;
import com.ruoyi.common.core.controller.BaseController;
//import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.validate.AddGroup;
import com.ruoyi.common.core.validate.EditGroup;
import com.ruoyi.common.core.validate.QueryGroup;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
//import com.ruoyi.gas.domain.bo.GPipeLengthBo;
//import com.ruoyi.gas.domain.vo.GPipeLengthVo;
//import com.ruoyi.gas.service.IGPipeLengthService;
import com.ruoyi.yiqi.entity.YqGPipeLength;
import com.ruoyi.yiqi.service.IYqGPipeLengthService;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Arrays;
import java.util.List;

/**
 * 管子长度Controller
 *
 * @author ruoyi
 * @date 2021-11-16
 */
@Validated
//@Api(value = "管子长度控制器", tags = {"管子长度管理"})
@RequiredArgsConstructor(onConstructor_ = @Autowired)
@RestController
@RequestMapping("/gas/pipeLength")
public class YqGPipeLengthController extends BaseController {

    private final IYqGPipeLengthService iGPipeLengthService;

    /**
     * 查询管子长度列表
     */
//    @ApiOperation("查询管子长度列表")
//    @PreAuthorize("@ss.hasPermi('gas:pipeLength:list')")
    @GetMapping("/list")
    public TableDataInfo<YqGPipeLength> list(@Validated(QueryGroup.class) YqGPipeLength bo) {
        return iGPipeLengthService.queryPageList(bo);
    }

    /**
     * 导出管子长度列表
     */
//    @ApiOperation("导出管子长度列表")
//    @PreAuthorize("@ss.hasPermi('gas:pipeLength:export')")
//    @Log(title = "管子长度", businessType = BusinessType.EXPORT)
//    @GetMapping("/export")
//    public void export(@Validated YqGPipeLength bo, HttpServletResponse response) {
//        List<YqGPipeLength> list = iGPipeLengthService.queryList(bo);
//        ExcelUtil.exportExcel(list, "管子长度", YqGPipeLength.class, response);
//    }

    /**
     * 获取管子长度详细信息
     */
//    @ApiOperation("获取管子长度详细信息")
//    @PreAuthorize("@ss.hasPermi('gas:pipeLength:query')")
    @GetMapping("/{id}")
    public R<YqGPipeLength> getInfo(@NotNull(message = "主键不能为空")
                                                  @PathVariable("id") Long id) {
        return R.ok(iGPipeLengthService.queryById(id));
    }

//    @GetMapping("/getList")
//    public AjaxResult getList() {
//        return AjaxResult.success(iGPipeLengthService.list());
//    }
}
