package com.ruoyi.yiqi.controller;

import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.annotation.RepeatSubmit;
import com.ruoyi.common.core.controller.BaseController;
//import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.validate.AddGroup;
import com.ruoyi.common.core.validate.EditGroup;
import com.ruoyi.common.core.validate.QueryGroup;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
//import com.ruoyi.gas.domain.bo.GValveBo;
//import com.ruoyi.gas.domain.vo.GValveVo;
//import com.ruoyi.gas.service.IGValveService;
import com.ruoyi.yiqi.entity.YqGValve;
import com.ruoyi.yiqi.service.IYqGValveService;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Arrays;
import java.util.List;

/**
 * 自闭阀类别Controller
 *
 * @author ruoyi
 * @date 2021-12-08
 */
@Validated
//@Api(value = "自闭阀类别控制器", tags = {"自闭阀类别管理"})
@RequiredArgsConstructor(onConstructor_ = @Autowired)
@RestController
@RequestMapping("/gas/valve")
public class YqGValveController extends BaseController {

    private final IYqGValveService iGValveService;

    /**
     * 查询自闭阀类别列表
     */
//    @ApiOperation("查询自闭阀类别列表")
//    @PreAuthorize("@ss.hasPermi('gas:valve:list')")
    @GetMapping("/list")
    public TableDataInfo<YqGValve> list(@Validated(QueryGroup.class) YqGValve bo) {
        return iGValveService.queryPageList(bo);
    }

    /**
     * 导出自闭阀类别列表
     */
//    @ApiOperation("导出自闭阀类别列表")
//    @PreAuthorize("@ss.hasPermi('gas:valve:export')")
//    @Log(title = "自闭阀类别", businessType = BusinessType.EXPORT)
//    @GetMapping("/export")
//    public void export(@Validated YqGValve bo, HttpServletResponse response) {
//        List<YqGValve> list = iGValveService.queryList(bo);
//        ExcelUtil.exportExcel(list, "自闭阀类别", YqGValve.class, response);
//    }

    /**
     * 获取自闭阀类别详细信息
     */
//    @ApiOperation("获取自闭阀类别详细信息")
//    @PreAuthorize("@ss.hasPermi('gas:valve:query')")
    @GetMapping("/{id}")
    public R<YqGValve> getInfo(@NotNull(message = "主键不能为空")
                                                  @PathVariable("id") Long id) {
        return R.ok(iGValveService.queryById(id));
    }

//    @GetMapping("/getList")
//    public R getList() {
//        return R.ok(iGValveService.list());
//    }
}
