package com.ruoyi.yiqi.controller;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.domain.entity.SysDictData;
import com.ruoyi.common.core.domain.entity.YqSysDictData;
import com.ruoyi.yiqi.entity.YqSysDict;
import com.ruoyi.yiqi.service.IYqSysDictDataService;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * 数据字典信息
 *
 * @author Lion Li
 */
@Validated
@RequiredArgsConstructor(onConstructor_ = @Autowired)
@RestController
@RequestMapping("/yq/system/dict/data")
public class YqSysDictDataController extends BaseController {

    private final IYqSysDictDataService dictDataService;

    /**
     * 根据字典类型查询字典数据信息
     */
    @GetMapping(value = "/type/{dictType}")
    public R<List> dictType(@PathVariable String dictType) {
        List<YqSysDictData> data = dictDataService.selectDictDataByType(dictType);
        if (ObjectUtils.isEmpty(data)) {
            data = new ArrayList<>();
        }else {
            List<YqSysDict> list = new ArrayList<>();
            for (YqSysDictData dictData: data) {
                YqSysDict dict = new YqSysDict();
                BeanUtils.copyProperties(dictData, dict);
                dict.setValue(dict.getDictValue());
                dict.setLabel(dict.getDictLabel());
                list.add(dict);
            }
            return R.ok(list);
        }
        return R.ok(data);
    }

}
