package com.ruoyi.yiqi.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.domain.BaseEntity;
import com.ruoyi.common.core.validate.AddGroup;
import com.ruoyi.common.core.validate.EditGroup;
import lombok.Data;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;

/**
 * 工程管理对象 g_order
 *
 * @author ruoyi
 * @date 2021-11-16
 */
@Data
@Accessors(chain = true)
@TableName("yq_g_order")
public class YqGOrder extends BaseEntity {

    private static final long serialVersionUID=1L;

    /**
     * 主键id
     */
    // @ApiModelProperty(value = "主键id")
    private Long id;
    private Long areaId;
    private String areaName;
    private Long buildingId;
    private String buildingName;
    private Long unitId;
    private String unitName;
    private Long foremanId;
    private Long workerId;
    private Long parentId;
    private String value;
    private String house;
    private String userName;




    /**
     * 订单号
     */
    // @ApiModelProperty(value = "订单号")
    private String orderNum;

    /**
     * 服务类别
     * 字典 ：001 上门未遇 002 正常施工 003 不符合规定
     * 非字典 004安检 005维修  006开栓
     */
    // @ApiModelProperty(value = "服务类别", required = true)
    @NotBlank(message = "服务类别不能为空", groups = { AddGroup.class, EditGroup.class })
    private String serviceType;

    /**
     * 工人id
     */
    // @ApiModelProperty(value = "工人id", required = true)
    @NotNull(message = "工人id不能为空", groups = { AddGroup.class, EditGroup.class })
    private Long userId;

    /**
     * 房屋id
     */
    // @ApiModelProperty(value = "房屋id")
    private Long houseId;
    private String houseName;

    /**
     * 管子长度
     */
    // @ApiModelProperty("管子长度")
    private String pipeLength;
    /**
     * 管子类别
     */
    // @ApiModelProperty("管子类别")
    private String pipeType;
    // @ApiModelProperty("自闭阀类型")
    private String valveType;
    /**
     * 订单状态
     */
    // @ApiModelProperty(value = "订单状态", required = true)
    private String orderStatus;

    /**
     * 审核状态
     */
    // @ApiModelProperty(value = "审核状态", required = true)
    private String examineStatus;

    /**
     * 备注
     */
    // @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 审核意见
     */
    private String reason;

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    // @ApiModelProperty("时间")
    private Date time;


//    /**
//     * 分页大小
//     */
//    // @ApiModelProperty("分页大小")
//    private Integer pageSize;
//
//    /**
//     * 当前页数
//     */
//    // @ApiModelProperty("当前页数")
//    private Integer pageNum;

    /**
     * 排序列
     */
    // @ApiModelProperty("排序列")
    private String orderByColumn;

    /**
     * 排序的方向desc或者asc
     */
    // @ApiModelProperty(value = "排序的方向", example = "asc,desc")
    private String isAsc;

    private List<String> photoList;
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    // @ApiModelProperty("时间")
    private Date starTime;
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    // @ApiModelProperty("时间")
    private Date endTime;
    /**
     * 工号前四位
     */
    private String jobNum;

    private Integer version;
    private String whether;
    private String district;

    /**
     * 分页大小
     */
    @TableField(exist = false)
    private Integer pageSize;

    /**
     * 当前页数
     */
    @TableField(exist = false)
    private Integer pageNum;

}
