package com.ruoyi.yiqi.entity;

import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.annotation.ExcelDictFormat;
import com.ruoyi.common.convert.ExcelDictConvert;
import com.ruoyi.common.core.domain.BaseEntity;
import lombok.Data;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * 其他工程对象 g_other_engine
 *
 * @author ruoyi
 * @date 2021-11-22
 */
@Data
@Accessors(chain = true)
@TableName("yq_g_other_engine")
public class YqGOtherEngine extends BaseEntity {

    private static final long serialVersionUID=1L;

    /**
     * 是否完工
     */
    @ExcelProperty(value = "是否完工", converter = ExcelDictConvert.class)
    @ExcelDictFormat(dictType = "engine_status")
//    @ApiModelProperty("是否完工")
    private String status;
    @ExcelProperty(value = "创建时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
//    @ApiModelProperty("创建时间")
    private Date time;
    @ExcelProperty(value = "修改时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
//    @ApiModelProperty("修改时间")
//    private Date updateTime;
    private List<String> photo;

    /**
     * 主键id
     */
    @TableId(value = "id")
    private Long id;
    /**
     * 工程名
     */
    private String name;
    /**
     * 项目类型
     */
    private String engineType;
    /**
     * 工程地址
     */
    private String address;
    /**
     * 备注
     */
    private String remark;
//    /**
//     * 是否完工
//     */
//    private String status;
//    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
//    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
//    private Date time;
    /**
     * 删除标志
     */
    @TableLogic
    private String delFlag;

    private String nbSort;

    /**
     * 分页大小
     */
    @TableField(exist = false)
    private Integer pageSize;

    /**
     * 当前页数
     */
    @TableField(exist = false)
    private Integer pageNum;

}
