package com.ruoyi.yiqi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.yiqi.entity.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 小区Service接口
 *
 * @author ruoyi
 * @date 2021-11-15
 */
public interface IYqGAreaService extends IService<YqGArea> {
	/**
	 * 查询单个
	 * @return
	 */
	YqGArea queryById(Long id);

	/**
	 * 查询列表
	 */
    TableDataInfo<YqGArea> queryPageList(YqGArea bo);

	/**
	 * 查询列表
	 */
	List<YqGArea> queryList(YqGArea bo);

	/**
	 * 根据新增业务对象插入小区
	 * @param bo 小区新增业务对象
	 * @return
	 */
	Boolean insertByBo(YqGArea bo);

	/**
	 * 根据编辑业务对象修改小区
	 * @param bo 小区编辑业务对象
	 * @return
	 */
	Boolean updateByBo(YqGArea bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	TableDataInfo<YqGArea> getList(YqGArea bo);
	List<YqGArea> getArea();

	List<GCensusVo> getExamineArea(Long areaId);
	List<GCensusVo> getExamineServe(Long id);
	List<GExportVo> getExportList();
	List<GExportsVo> getExport(YqGArea bo);
	String getDictNameOfAffiliatedPackage(YqGArea bo);
	/**
	 * 导入用户数据
	 *
	 * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
	 * @param operName        操作用户
	 * @return 结果
	 */
	Map<String,Object> importUser(List<GImportVo> list, Boolean isUpdateSupport, String operName, int n, int successNum);
	String importApprovalExcel(List<GImportVo> list, Boolean isUpdateSupport, String operName);
	String importUserA(List<GImportVo> list, Boolean isUpdateSupport, String operName);

    void write(List<Long> ids);

	List<GCensusVo> getAreaSum(Long areaId);

	void upload(HttpServletRequest request, HttpServletResponse response, Long id);

	Boolean releaseIs(Long id);

	List<String> getPhoto(Long id);

	Boolean getForName(String name,String id);

	/**
	 * 导出小区完工率
	 * @param areaId
	 * @return
	 */
	List<GAreaExportVo> getExportHouse(Long areaId);

    void deleteDirectory(String name);
}
