package com.ruoyi.yiqi.service;


import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.yiqi.entity.YqGBuilding;

import java.util.Collection;
import java.util.List;

/**
 * 楼宇Service接口
 *
 * @author ruoyi
 * @date 2021-11-15
 */
public interface IYqGBuildingService extends IService<YqGBuilding> {
	/**
	 * 查询单个
	 * @return
	 */
	YqGBuilding queryById(Long id);

	/**
	 * 查询列表
	 */
    TableDataInfo<YqGBuilding> queryPageList(YqGBuilding bo);

	/**
	 * 查询列表
	 */
	List<YqGBuilding> queryList(YqGBuilding bo);

	/**
	 * 根据新增业务对象插入楼宇
	 * @param bo 楼宇新增业务对象
	 * @return
	 */
	Boolean insertByBo(YqGBuilding bo);

	/**
	 * 根据编辑业务对象修改楼宇
	 * @param bo 楼宇编辑业务对象
	 * @return
	 */
	Boolean updateByBo(YqGBuilding bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	TableDataInfo<YqGBuilding> getList(YqGBuilding bo);
	List<YqGBuilding> getBuilding(Long areaId);
}
