package com.ruoyi.yiqi.service;


import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.yiqi.entity.YqGUnit;

import java.util.Collection;
import java.util.List;

/**
 * 单元Service接口
 *
 * @author ruoyi
 * @date 2021-11-15
 */
public interface IYqGUnitService extends IService<YqGUnit> {
	/**
	 * 查询单个
	 * @return
	 */
	YqGUnit queryById(Long id);

	/**
	 * 查询列表
	 */
    TableDataInfo<YqGUnit> queryPageList(YqGUnit bo);

	/**
	 * 查询列表
	 */
	List<YqGUnit> queryList(YqGUnit bo);

	/**
	 * 根据新增业务对象插入单元
	 * @param bo 单元新增业务对象
	 * @return
	 */
	Boolean insertByBo(YqGUnit bo);

	/**
	 * 根据编辑业务对象修改单元
	 * @param bo 单元编辑业务对象
	 * @return
	 */
	Boolean updateByBo(YqGUnit bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	TableDataInfo<YqGUnit> getList(YqGUnit bo);

	YqGUnit getById(Long id);

	List<YqGUnit> getUnit(Long buildingId);
}
