package com.ruoyi.yiqi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.yiqi.entity.YqGUser;

import java.util.Collection;
import java.util.List;

/**
 * 用户Service接口
 *
 * @author ruoyi
 * @date 2021-11-12
 */
public interface IYqGUserService extends IService<YqGUser> {
	/**
	 * 查询单个
	 * @return
	 */
	YqGUser queryById(Long id);

	/**
	 * 查询列表
	 */
    TableDataInfo<YqGUser> queryPageList(YqGUser bo);

	/**
	 * 查询列表
	 */
	List<YqGUser> queryList(YqGUser bo);

	/**
	 * 根据新增业务对象插入用户
	 * @param bo 用户新增业务对象
	 * @return
	 */
	Boolean insertByBo(YqGUser bo);

	/**
	 * 根据编辑业务对象修改用户
	 * @param bo 用户编辑业务对象
	 * @return
	 */
	Boolean updateByBo(YqGUser bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	TableDataInfo<YqGUser> getList(YqGUser bo);


	/**
	 * 工人下拉
	 * @return
	 */
	List<YqGUser>  getWorker();

	/**
	 * 黑名单列表
	 * @param bo
	 * @return
	 */
	TableDataInfo<YqGUser> getBlacklist(YqGUser bo);

	List<YqGUser> getExamineForeman(Long foremanId);
	List<YqGUser> getExamineWorker(Long workerId);
	Boolean getForPhone(Long phone,String id);
	Boolean getForJobnum(String jobNum,String id);
}
