package com.ruoyi.yiqi.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.page.PagePlus;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.yiqi.entity.YqGBuilding;
import com.ruoyi.yiqi.entity.YqGUser;
import com.ruoyi.yiqi.mapper.YqGBuildingMapper;
import com.ruoyi.yiqi.service.IYqGBuildingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.function.Function;

/**
 * 楼宇Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-15
 */
@Service
public class YqGBuildingServiceImpl implements IYqGBuildingService {
    @Autowired
    private YqGBuildingMapper gBuildingMapper;
    @Override
    public YqGBuilding queryById(Long id){
        return gBuildingMapper.selectVoById(id);
    }

    @Override
    public TableDataInfo<YqGBuilding> queryPageList(YqGBuilding bo) {
        Page<YqGBuilding> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGBuilding> list = gBuildingMapper.getList(bo,page);
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public List<YqGBuilding> queryList(YqGBuilding bo) {
        return gBuildingMapper.selectList(buildQueryWrapper(bo));
    }

    private LambdaQueryWrapper<YqGBuilding> buildQueryWrapper(YqGBuilding bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<YqGBuilding> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getName()), YqGBuilding::getName, bo.getName());
        lqw.eq(bo.getAreaId() != null, YqGBuilding::getAreaId, bo.getAreaId());
        return lqw;
    }

    @Override
    public Boolean insertByBo(YqGBuilding bo) {
        YqGBuilding add = BeanUtil.toBean(bo, YqGBuilding.class);
        validEntityBeforeSave(add);
        boolean flag = false;
        Long count = gBuildingMapper.checkDataList(bo);
        if(count == 0){
            flag = save(add);
            if (flag) {
                bo.setId(add.getId());
            }
        }
        return flag;
    }

    @Override
    public boolean saveBatch(Collection<YqGBuilding> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean saveOrUpdateBatch(Collection<YqGBuilding> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean updateBatchById(Collection<YqGBuilding> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean saveOrUpdate(YqGBuilding entity) {
        return false;
    }

    @Override
    public YqGBuilding getOne(Wrapper<YqGBuilding> queryWrapper, boolean throwEx) {
        return null;
    }

    @Override
    public Optional<YqGBuilding> getOneOpt(Wrapper<YqGBuilding> queryWrapper, boolean throwEx) {
        return Optional.empty();
    }

    @Override
    public Map<String, Object> getMap(Wrapper<YqGBuilding> queryWrapper) {
        return new HashMap<>();
    }

    @Override
    public <V> V getObj(Wrapper<YqGBuilding> queryWrapper, Function<? super Object, V> mapper) {
        return null;
    }

    @Override
    public BaseMapper<YqGBuilding> getBaseMapper() {
        return null;
    }

    @Override
    public Class<YqGBuilding> getEntityClass() {
        return null;
    }

    @Override
    public Boolean updateByBo(YqGBuilding bo) {
        YqGBuilding update = BeanUtil.toBean(bo, YqGBuilding.class);
        validEntityBeforeSave(update);
        return updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(YqGBuilding entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return removeByIds(ids);
    }

    @Override
    public TableDataInfo<YqGBuilding> getList(YqGBuilding bo) {
        Page<YqGBuilding> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGBuilding> list = gBuildingMapper.getList(bo,page);
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public List<YqGBuilding> getBuilding(Long areaId) {
        return gBuildingMapper.getBuilding(areaId);
    }
}
