package com.ruoyi.yiqi.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.yiqi.entity.YqGHouse;
import com.ruoyi.yiqi.entity.YqGUnit;
import com.ruoyi.yiqi.mapper.YqGHouseMapper;
import com.ruoyi.yiqi.service.IYqGHouseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;
import java.util.function.Function;

/**
 * 房屋Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-15
 */
@Service
public class YqGHouseServiceImpl implements IYqGHouseService {
    @Resource
    private YqGHouseMapper gHouseMapper;
    @Override
    public YqGHouse queryById(Long id){
        return gHouseMapper.selectVoById(id);
    }

    @Override
    public TableDataInfo<YqGHouse> queryPageList(YqGHouse bo) {
        Page<YqGHouse> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGHouse> result = gHouseMapper.getList(bo, page);
        return PageUtils.buildDataInfo(result);
    }

    @Override
    public List<YqGHouse> queryList(YqGHouse bo) {
        return gHouseMapper.selectVoList(buildQueryWrapper(bo));
    }

    private LambdaQueryWrapper<YqGHouse> buildQueryWrapper(YqGHouse bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<YqGHouse> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getName()), YqGHouse::getName, bo.getName());
        lqw.eq(bo.getUnitId() != null, YqGHouse::getUnitId, bo.getUnitId());
        return lqw;
    }

    @Override
    public Boolean insertByBo(YqGHouse bo) {
        YqGHouse add = BeanUtil.toBean(bo, YqGHouse.class);
        validEntityBeforeSave(add);
        boolean flag = false;
        Long count = gHouseMapper.checkDataList(bo);
        if(count == 0){
            flag = save(add);
            if (flag) {
                bo.setId(add.getId());
            }
        }

        return flag;
    }

    @Override
    public Boolean updateByBo(YqGHouse bo) {
        YqGHouse update = BeanUtil.toBean(bo, YqGHouse.class);
        validEntityBeforeSave(update);
        return updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(YqGHouse entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return removeByIds(ids);
    }

    @Override
    public TableDataInfo<YqGHouse> getList(YqGHouse bo) {
        Page<YqGHouse> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        Page<YqGHouse> list = gHouseMapper.getList(bo,page);
        return PageUtils.buildDataInfo(list);
    }

    @Override
    public YqGHouse getById(Long id) {
        return gHouseMapper.getById(id);
    }

    @Override
    public List<YqGHouse> getHouse(Long unitId) {
        return gHouseMapper.getHouse(unitId);
    }

    @Override
    public boolean saveBatch(Collection<YqGHouse> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean saveOrUpdateBatch(Collection<YqGHouse> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean updateBatchById(Collection<YqGHouse> entityList, int batchSize) {
        return false;
    }

    @Override
    public boolean saveOrUpdate(YqGHouse entity) {
        return false;
    }

    @Override
    public YqGHouse getOne(Wrapper<YqGHouse> queryWrapper, boolean throwEx) {
        return null;
    }

    @Override
    public Optional<YqGHouse> getOneOpt(Wrapper<YqGHouse> queryWrapper, boolean throwEx) {
        return Optional.empty();
    }

    @Override
    public Map<String, Object> getMap(Wrapper<YqGHouse> queryWrapper) {
        return new HashMap<>();
    }

    @Override
    public <V> V getObj(Wrapper<YqGHouse> queryWrapper, Function<? super Object, V> mapper) {
        return null;
    }

    @Override
    public BaseMapper<YqGHouse> getBaseMapper() {
        return null;
    }

    @Override
    public Class<YqGHouse> getEntityClass() {
        return null;
    }
}
