package com.ruoyi.zdsz.service.impl;

import com.github.therapi.runtimejavadoc.repack.com.eclipsesource.json.Json;
import com.github.therapi.runtimejavadoc.repack.com.eclipsesource.json.JsonObject;
import com.github.therapi.runtimejavadoc.repack.com.eclipsesource.json.JsonValue;
import com.ruoyi.common.core.domain.entity.SysDictData;
import com.ruoyi.common.utils.redis.RedisUtils;
import com.ruoyi.zdsz.domain.bo.ZdszBigscreenBo;
import com.ruoyi.zdsz.mapper.*;
import com.ruoyi.zdsz.service.IZdszBigscreenService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 大屏首页Service业务层处理
 *
 * @author ruoyi
 * @date 2024-08-05
 */
@RequiredArgsConstructor
@Service
public class ZdszBigscreenServiceImpl implements IZdszBigscreenService {
    @Resource
    private ZEnginSpecificationsMapper specificationsMapper;
    @Resource
    private ZEnginMaterialQualityMapper materialQualityMapper;
    @Resource
    private ZdszBigscreenMapper bigscreenMapper;
    @Resource
    private ZEngineeringGYMapper zEngineeringGYMapper;
    @Resource
    private ZEngineeringIndustryMapper zEngineeringIndustryMapper;
    @Resource
    private ZEngineeringInfrastructureMapper zEngineeringInfrastructureMapper;
    @Resource
    private ZEngineeringCivilMapper zEngineeringCivilMapper;
    @Resource
    private ZTouchOperationEngineeringMapper zTouchOperationEngineeringMapper;
    @Resource
    private ZEngineeringPipeJackingMapper zEngineeringPipeJackingMapper;

    /**
     * 施工进度统计
     */
    public void setConstructionProgress(String initTime){
        ZdszBigscreenBo zdszBigscreenBo = new ZdszBigscreenBo();
        String time = getPreviousDay();
        if(initTime != null){
            time = initTime;
        }
        zdszBigscreenBo.setTime(time);
        Double iron = 0.0;
        Double pe = 0.0;
        Double stainless_steel_bellow =  0.0;
        Double spiral_welded_pipe = 0.0;
        Double seamless_steel_tube = 0.0;
        Double galvanized_steel_pipe = 0.0;
        Double polyethylene_pipe = 0.0;
        List<String> monthList = batchInitMonthList(null);
        for (String month: monthList) {
            String[] times = month.split("-");
            zdszBigscreenBo.setMaterial("z_engineering_material_" + times[0] + "_" + times[1]); // z_engineering_material_2024_08
            List<Double> numbers= bigscreenMapper.pipeNum(zdszBigscreenBo);
            iron += numbers.get(0);
            pe += numbers.get(1);
            stainless_steel_bellow += numbers.get(2);
            spiral_welded_pipe += numbers.get(3);
            seamless_steel_tube += numbers.get(4);
            galvanized_steel_pipe += numbers.get(5);
            polyethylene_pipe += numbers.get(6);
        }
        Map map = new HashMap();
        map.put("time", time); // 创建时间
        map.put("iron", iron); // 钢管总数
        map.put("pe", pe); // PE总数
        map.put("stainless_steel_bellow", stainless_steel_bellow); // 不锈钢波纹管
        map.put("spiral_welded_pipe", spiral_welded_pipe); // 螺旋焊管
        map.put("seamless_steel_tube", seamless_steel_tube); // 无缝钢管
        map.put("galvanized_steel_pipe", galvanized_steel_pipe); // 镀锌钢管
        map.put("polyethylene_pipe", polyethylene_pipe); // 燃气用埋地聚乙烯管
        bigscreenMapper.setConstructionProgress(map);
    }

    @Override
    public Map getConstructionProgress(ZdszBigscreenBo zdszBigscreenBo){
        String time = zdszBigscreenBo.getTime();
        if(time == null){
            zdszBigscreenBo.setTime(getPreviousDay());
        }else if(time.equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))){
            setConstructionProgress(time);
        }
        clearTime(zdszBigscreenBo);
        List<Map> list = bigscreenMapper.getConstructionProgress(zdszBigscreenBo);
        int size = list.size();
        switch (size){
            case 0:{
                Map map = new LinkedHashMap();
                map.put("time", time); // 当日时间
                map.put("iron", 0); // 钢管总数
                map.put("pe", 0); // PE总数
                map.put("stainless_steel_bellow", 0); // 不锈钢波纹管
                map.put("spiral_welded_pipe", 0); // 螺旋焊管
                map.put("seamless_steel_tube", 0); // 无缝钢管
                map.put("galvanized_steel_pipe", 0); // 镀锌钢管
                map.put("polyethylene_pipe", 0); // 燃气用埋地聚乙烯管
                return map;
            }
            case 1:{
                return list.get(0);
            }
            default:{
                Map map = new LinkedHashMap();
                map.put("time", time); // 当日时间
                map.put("iron", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("iron")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 钢管总数
                map.put("pe", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("pe")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // PE总数
                map.put("stainless_steel_bellow", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("stainless_steel_bellow")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 不锈钢波纹管
                map.put("spiral_welded_pipe", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("spiral_welded_pipe")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 螺旋焊管
                map.put("seamless_steel_tube", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("seamless_steel_tube")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 无缝钢管
                map.put("galvanized_steel_pipe", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("galvanized_steel_pipe")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 镀锌钢管
                map.put("polyethylene_pipe", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("polyethylene_pipe")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 燃气用埋地聚乙烯管
                return map;
            }
        }
    }

    /**
     * 工程状态统计
     */
    public void setProjectStatus(String initTime){
        ZdszBigscreenBo zdszBigscreenBo = new ZdszBigscreenBo();
        String time = getPreviousDay();
        if(initTime != null){
            time = initTime;
        }
        zdszBigscreenBo.setTime(time);

//        LambdaQueryWrapper<ZEngineeringIndustry> zEngineeringIndustryBoLambdaQueryWrapper = new LambdaQueryWrapper<ZEngineeringIndustry>();
//        List<ZEngineeringIndustry> zEngineeringIndustryVos = baseMapper.selectList(zEngineeringIndustryBoLambdaQueryWrapper);
//        LambdaQueryWrapper lqw = new
//        zEngineeringGYMapper.selectList()
        Map map = new HashMap();
        map.put("time", time); // 创建时间
        map.put("todo", bigscreenMapper.todoNum(zdszBigscreenBo)); // 开工
        map.put("doing", bigscreenMapper.doingNum(zdszBigscreenBo)); // 在建
        map.put("done", bigscreenMapper.doneNum(zdszBigscreenBo)); // 完工
        bigscreenMapper.setProjectStatus(map);
    }

    @Override
    public Map getProjectStatus(ZdszBigscreenBo zdszBigscreenBo){
        String time = zdszBigscreenBo.getTime();
        if(time == null){
            zdszBigscreenBo.setTime(getPreviousDay());
        }else if(time.equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))){
            setProjectStatus(time);
        }
        clearTime(zdszBigscreenBo);
        List<Map> list = bigscreenMapper.getProjectStatus(zdszBigscreenBo);
        int size = list.size();
        switch (size){
            case 0:{
                Map map = new LinkedHashMap();
                map.put("todo", 0); // 开工
                map.put("doing", 0); // 在建
                map.put("done", 0); // 完工
                return map;
            }
            case 1:{
                return list.get(0);
            }
            default:{
                Map map = new LinkedHashMap();
                map.put("todo", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("todo")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 开工
                map.put("doing", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("doing")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 在建
                map.put("done", list.get(list.size()-1).get("done")); // 完工
                return map;
            }
        }
    }

    /**
     * 今日施工数
     */
    public void setCountEngineering(String initTime){
        ZdszBigscreenBo zdszBigscreenBo = new ZdszBigscreenBo();
        String time = getPreviousDay();
        if(initTime != null){
            time = initTime;
        }
        zdszBigscreenBo.setTime(time);
        Map map = new HashMap();
        map.put("time", time); // 创建时间
//        Long civi = 0L;
//        Long gy = 0L;
//        Long industry = 0L;
//        Long touch = 0L;
//        Long infrastructure = 0L;
//        Long pipe = 0L;
        Set civi = new HashSet();
        Set gy = new HashSet();
        Set industry = new HashSet();
        Set touch = new HashSet();
        Set infrastructure = new HashSet();
        Set pipe = new HashSet();
        List<String> monthList = batchInitMonthList(null);
        for (String month: monthList) {
            String[] times = month.split("-");
            zdszBigscreenBo.setInfo("z_engineering_info_" + times[0] + "_" + times[1]); // z_engineering_info_2024_03
            zdszBigscreenBo.setNode("z_engineering_node_" + times[0] + "_" + times[1]); // z_engineering_node_2024_03
            setMergeList(civi, bigscreenMapper.civiNumEng(zdszBigscreenBo));
            setMergeList(gy, bigscreenMapper.gyNumEng(zdszBigscreenBo));
            setMergeList(industry, bigscreenMapper.industryNumEng(zdszBigscreenBo));
            setMergeList(touch, bigscreenMapper.touchNumEng(zdszBigscreenBo));
            setMergeList(infrastructure, bigscreenMapper.infrastructureNumEng(zdszBigscreenBo));
            setMergeList(pipe, bigscreenMapper.pipeNumEng(zdszBigscreenBo));
//            civi.add(bigscreenMapper.civiNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            gy.add(bigscreenMapper.gyNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            industry.add(bigscreenMapper.industryNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            touch.add(bigscreenMapper.touchNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            infrastructure.add(bigscreenMapper.infrastructureNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            pipe.add(bigscreenMapper.pipeNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));

//            civi.add(bigscreenMapper.civiNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            gy.add(bigscreenMapper.gyNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            industry.add(bigscreenMapper.industryNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            touch.add(bigscreenMapper.touchNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            infrastructure.add(bigscreenMapper.infrastructureNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            pipe.add(bigscreenMapper.pipeNumEng(zdszBigscreenBo).stream().collect(Collectors.toSet()));
//            pipe += bigscreenMapper.gyNumEng(zdszBigscreenBo);
//            industry += bigscreenMapper.industryNumEng(zdszBigscreenBo);
//            touch += bigscreenMapper.touchNumEng(zdszBigscreenBo);
//            infrastructure += bigscreenMapper.infrastructureNumEng(zdszBigscreenBo);
//            pipe += bigscreenMapper.pipeNumEng(zdszBigscreenBo);
        }
        map.put("civi", civi.size()); // 民用工程
        map.put("gy", gy.size()); // 工业工程
        map.put("industry", industry.size()); // 市政工程
        map.put("touch", touch.size()); // 碰口工程
        map.put("infrastructure", infrastructure.size()); // 基建工程
        map.put("pipe", pipe.size()); // 顶管工程
        bigscreenMapper.setCountEngineering(map);
    }
    private void setMergeList(Set set, List<String> list){
        for (String string: list) {
            if(string != null){
                set.add(string);
            }
        }
    }
    @Override
    public Map getCountEngineering(ZdszBigscreenBo zdszBigscreenBo){
        String time = zdszBigscreenBo.getTime();
        if(time == null){
            zdszBigscreenBo.setTime(getPreviousDay());
        }else if(time.equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))){
            setCountEngineering(time);
        }
        clearTime(zdszBigscreenBo);
        List<Map> list = bigscreenMapper.getCountEngineering(zdszBigscreenBo);
        int size = list.size();
        switch (size){
            case 0:{
                Map map = new LinkedHashMap();
                map.put("civi", 0); // 民用工程
                map.put("gy", 0); // 工业工程
                map.put("industry", 0); // 市政工程
                map.put("touch", 0); // 碰口工程
                map.put("infrastructure", 0); // 基建工程
                map.put("pipe", 0); // 顶管工程
                return map;
            }
            case 1:{
                return list.get(0);
            }
            default:{
                Map map = new LinkedHashMap();
                map.put("civi", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("civi")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 民用工程
                map.put("gy", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("gy")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 工业工程
                map.put("industry", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("industry")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 市政工程
                map.put("touch", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("touch")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 碰口工程
                map.put("infrastructure", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("infrastructure")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 基建工程
                map.put("pipe", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("pipe")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 顶管工程
                return map;
            }
        }
    }

    /**
     * 今日使用人数
     */
    public void setCountPerson(String initTime){
        ZdszBigscreenBo zdszBigscreenBo = new ZdszBigscreenBo();
        String time = getPreviousDay();
        if(initTime != null){
            time = initTime;
        }
        zdszBigscreenBo.setTime(time);
        Map map = new HashMap();
        map.put("time", time); // 创建时间
        map.put("civi", bigscreenMapper.civiNumPer(zdszBigscreenBo)); // 民用工程
        map.put("gy", bigscreenMapper.gyNumPer(zdszBigscreenBo)); // 工业工程
        map.put("industry", bigscreenMapper.industryNumPer(zdszBigscreenBo)); // 市政工程
        map.put("touch", bigscreenMapper.touchNumPer(zdszBigscreenBo)); // 碰口工程
        map.put("infrastructure", bigscreenMapper.infrastructureNumPer(zdszBigscreenBo)); // 基建工程
        map.put("pipe", bigscreenMapper.pipeNumPer(zdszBigscreenBo)); // 顶管工程
        bigscreenMapper.setCountPerson(map);
    }
    @Override
    public Map getCountPerson(ZdszBigscreenBo zdszBigscreenBo){
        String time = zdszBigscreenBo.getTime();
        if(time == null){
            zdszBigscreenBo.setTime(getPreviousDay());
        }else if(time.equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))){
            setCountPerson(time);
        }
        clearTime(zdszBigscreenBo);
        List<Map> list = bigscreenMapper.getCountPerson(zdszBigscreenBo);
        int size = list.size();
        switch (size){
            case 0:{
                Map map = new LinkedHashMap();
                map.put("civi", 0); // 民用工程
                map.put("gy", 0); // 工业工程
                map.put("industry", 0); // 市政工程
                map.put("touch", 0); // 碰口工程
                map.put("infrastructure", 0); // 基建工程
                map.put("pipe", 0); // 顶管工程
                return map;
            }
            case 1:{
                return list.get(0);
            }
            default:{
                Map map = new LinkedHashMap();
                map.put("civi", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("civi")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 民用工程
                map.put("gy", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("gy")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 工业工程
                map.put("industry", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("industry")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 市政工程
                map.put("touch", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("touch")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 碰口工程
                map.put("infrastructure", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("infrastructure")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 基建工程
                map.put("pipe", list.stream().map(x -> new BigDecimal(String.valueOf(x.get("pipe")))).reduce(BigDecimal.ZERO, BigDecimal::add)); // 顶管工程
                return map;
            }
        }
    }

    /**
     * 地图施工数据分布
     */
    public void setConstructionMap(String initTime){
        ZdszBigscreenBo zdszBigscreenBo = new ZdszBigscreenBo();
        String time = getPreviousDay();
        if(initTime != null){
            time = initTime;
        }
//        time = "2024-03-10";
        zdszBigscreenBo.setTime(time);
        Map map = new HashMap();
        map.put("time", time); // 创建时间
        List<Map> initMaps = new ArrayList<>();
        List<String> monthList = batchInitMonthList(null);
        for (String month: monthList) {
            String[] times = month.split("-");
            zdszBigscreenBo.setInfo("z_engineering_info_" + times[0] + "_" + times[1]); // z_engineering_info_2024_03
            zdszBigscreenBo.setNode("z_engineering_node_" + times[0] + "_" + times[1]); // z_engineering_node_2024_03
//            List<Map> civiOldMaps = calculateMapData(bigscreenMapper.civiNumOld(zdszBigscreenBo)); // 民用工程 旧改
//            List<Map> civiMaps = calculateMapData(bigscreenMapper.civiNumNew(zdszBigscreenBo)); // 民用工程 新建
            List<Map> civiMaps = calculateMapData(bigscreenMapper.civiNumMap(zdszBigscreenBo)); // 民用工程 新建 旧改
            List<Map> gyMaps = calculateMapData(bigscreenMapper.gyNumNew(zdszBigscreenBo)); // 工业工程
            List<Map> industryMaps = calculateMapData(bigscreenMapper.industryNumNew(zdszBigscreenBo)); // 市政工程
            List<Map> touchMaps = calculateMapData(bigscreenMapper.touchNumNew(zdszBigscreenBo)); // 碰口工程
            List<Map> infrastructureMaps = calculateMapData(bigscreenMapper.infrastructureNumNew(zdszBigscreenBo)); // 基建工程
            List<Map> pipeMaps = calculateMapData(bigscreenMapper.pipeNumNew(zdszBigscreenBo)); // 顶管工程
            initMaps = mapMergeMapById(initMaps, civiMaps);
            initMaps = mapMergeMapById(initMaps, gyMaps);
            initMaps = mapMergeMapById(initMaps, industryMaps);
            initMaps = mapMergeMapById(initMaps, touchMaps);
            initMaps = mapMergeMapById(initMaps, infrastructureMaps);
            initMaps = mapMergeMapById(initMaps, pipeMaps);
//            initMaps = mapMergeMapById(initMaps, civiOldMaps);
        }
        map.put("json", mapToJson(initMaps)); // JSON数据
        bigscreenMapper.setConstructionMap(map);
    }
    @Override
    public Map getConstructionMap(ZdszBigscreenBo zdszBigscreenBo){
        String time = zdszBigscreenBo.getTime();
        if(time == null){
            zdszBigscreenBo.setTime(getPreviousDay());
        }else if(time.equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))){
            setConstructionMap(time);
        }
        clearTime(zdszBigscreenBo);
        Map<String, List<SysDictData>> sysDictMap = RedisUtils.getCacheMap("sys_dict");
        List<SysDictData> dictDataList = sysDictMap.get("district");
        List<Map> list = bigscreenMapper.getConstructionMap(zdszBigscreenBo);
        int size = list.size();
        switch (size){
            case 0:{
                List names = new ArrayList();
                List values = new ArrayList();
                for (SysDictData dictData: dictDataList) {
                    names.add(dictData.getDictLabel());
                    values.add(0);
                }
                Map map = new LinkedHashMap();
                map.put("name", names); // 名称
                map.put("value", values); // 数量
                return map;
            }
            case 1:{
                List names = new ArrayList();
                List values = new ArrayList();
                Map map = list.get(0);
                String jsonStr = map.get("json").toString();
                JsonValue jsonValue = Json.parse(jsonStr);
                JsonObject jsonObject = jsonValue.asObject();
                for (SysDictData dictData: dictDataList) {
                    names.add(dictData.getDictLabel());
                    Object value = jsonObject.get(dictData.getDictValue());
                    values.add(value == null ? 0 : Long.valueOf(value.toString()));
                }
                Map linkedHashMap = new LinkedHashMap();
                linkedHashMap.put("name", names); // 名称
                linkedHashMap.put("value", values); // 数量
                return linkedHashMap;
            }
            default:{
                List names = new ArrayList();
                List values = new ArrayList();
                for (SysDictData dictData: dictDataList) {
                    names.add(dictData.getDictLabel());
                    Long longValue = 0L;
                    for (int i = 0; i < list.size(); i++) {
                        Map map = list.get(i);
                        String jsonStr = map.get("json").toString();
                        JsonValue jsonValue = Json.parse(jsonStr);
                        JsonObject jsonObject = jsonValue.asObject();
                        Object valueObj = jsonObject.get(dictData.getDictValue());
                        Long value = valueObj == null ? 0L : Long.valueOf(valueObj.toString());
                        longValue += value;
                    }
                    values.add(longValue);
                }
                Map linkedHashMap = new LinkedHashMap();
                linkedHashMap.put("name", names); // 名称
                linkedHashMap.put("value", values); // 数量
                return linkedHashMap;
            }
        }
    }

    /**
     * 各个区今日施工数
     */
    public void setConstructionNew(String initTime){
        ZdszBigscreenBo zdszBigscreenBo = new ZdszBigscreenBo();
        String time = getPreviousDay();
        if(initTime != null){
            time = initTime;
        }
        zdszBigscreenBo.setTime(time);
        Map map = new HashMap();
        map.put("time", time); // 创建时间
        List<Map> initMaps = new ArrayList<>();
        List<Map> initMaps_civi = new ArrayList<>();
        List<Map> initMaps_gy = new ArrayList<>();
        List<Map> initMaps_industry = new ArrayList<>();
        List<Map> initMaps_touch = new ArrayList<>();
        List<Map> initMaps_infrastructure = new ArrayList<>();
        List<Map> initMaps_pipe = new ArrayList<>();
        List<String> monthList = batchInitMonthList(null);
        for (String month: monthList) {
            String[] times = month.split("-");
            zdszBigscreenBo.setInfo("z_engineering_info_" + times[0] + "_" + times[1]); // z_engineering_info_2024_03
            zdszBigscreenBo.setNode("z_engineering_node_" + times[0] + "_" + times[1]); // z_engineering_node_2024_03
            List<Map> civiMaps = calculateMapData(bigscreenMapper.civiNumNew(zdszBigscreenBo)); // 民用工程
            List<Map> gyMaps = calculateMapData(bigscreenMapper.gyNumNew(zdszBigscreenBo)); // 工业工程
            List<Map> industryMaps = calculateMapData(bigscreenMapper.industryNumNew(zdszBigscreenBo)); // 市政工程
            List<Map> touchMaps = calculateMapData(bigscreenMapper.touchNumNew(zdszBigscreenBo)); // 碰口工程
            List<Map> infrastructureMaps = calculateMapData(bigscreenMapper.infrastructureNumNew(zdszBigscreenBo)); // 基建工程
            List<Map> pipeMaps = calculateMapData(bigscreenMapper.pipeNumNew(zdszBigscreenBo)); // 顶管工程
            initMaps_civi = mapMergeMapById(initMaps_civi, civiMaps);
            initMaps_gy = mapMergeMapById(initMaps_gy, gyMaps);
            initMaps_industry = mapMergeMapById(initMaps_industry, industryMaps);
            initMaps_touch = mapMergeMapById(initMaps_touch, touchMaps);
            initMaps_infrastructure = mapMergeMapById(initMaps_infrastructure, infrastructureMaps);
            initMaps_pipe = mapMergeMapById(initMaps_pipe, pipeMaps);
        }
        initMaps = mapMergeMap(initMaps, initMaps_civi);
        initMaps = mapMergeMap(initMaps, initMaps_gy);
        initMaps = mapMergeMap(initMaps, initMaps_industry);
        initMaps = mapMergeMap(initMaps, initMaps_touch);
        initMaps = mapMergeMap(initMaps, initMaps_infrastructure);
        initMaps = mapMergeMap(initMaps, initMaps_pipe);
        map.put("json", mapToJson(initMaps)); // JSON数据
        bigscreenMapper.setConstructionNew(map);
    }
    @Override
    public Map getConstructionNew(ZdszBigscreenBo zdszBigscreenBo){
        String time = zdszBigscreenBo.getTime();
        if(time == null){
            zdszBigscreenBo.setTime(getPreviousDay());
        }else if(time.equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))){
            setConstructionNew(time);
        }
        Map<String, List<SysDictData>> sysDictMap = RedisUtils.getCacheMap("sys_dict");
        List<SysDictData> dictDataList = sysDictMap.get("district");
        clearTime(zdszBigscreenBo);
        List<Map> list = bigscreenMapper.getConstructionNew(zdszBigscreenBo);
        int size = list.size();
        switch (size){
            case 0:{
                List names = new ArrayList();
                List values = new ArrayList();
                for (SysDictData dictData: dictDataList) {
//                    names.add(dictData.getDictLabel());
                    if(dictData.getRemark().equals("门市房")){
                        continue;
                    }
                    names.add(dictData.getRemark());
                    values.add(0);
                }
                Map map = new LinkedHashMap();
                map.put("name", names); // 名称
                map.put("value", values); // 数量
                return map;
            }
            case 1:{
                List names = new ArrayList();
                List values = new ArrayList();
                Map map = list.get(0);
                String jsonStr = map.get("json").toString();
                JsonValue jsonValue = Json.parse(jsonStr);
                JsonObject jsonObject = jsonValue.asObject();
                for (SysDictData dictData: dictDataList) {
//                    names.add(dictData.getDictLabel());
                    if(dictData.getRemark().equals("门市房")){
                        continue;
                    }
                    names.add(dictData.getRemark());
                    Object value = jsonObject.get(dictData.getDictValue());
                    values.add(value == null ? 0 : Long.valueOf(value.toString()));
                }
                Map linkedHashMap = new LinkedHashMap();
                linkedHashMap.put("name", names); // 名称
                linkedHashMap.put("value", values); // 数量
                return linkedHashMap;
            }
            default:{
                List names = new ArrayList();
                List values = new ArrayList();
                for (SysDictData dictData: dictDataList) {
//                    names.add(dictData.getDictLabel());
                    if(dictData.getRemark().equals("门市房")){
                        continue;
                    }
                    names.add(dictData.getRemark());
                    Long longValue = 0L;
                    for (int i = 0; i < list.size(); i++) {
                        Map map = list.get(i);
                        String jsonStr = map.get("json").toString();
                        JsonValue jsonValue = Json.parse(jsonStr);
                        JsonObject jsonObject = jsonValue.asObject();
                        Object valueObj = jsonObject.get(dictData.getDictValue());
                        Long value = valueObj == null ? 0L : Long.valueOf(valueObj.toString());
                        longValue += value;
                    }
                    values.add(longValue);
                }
                Map linkedHashMap = new LinkedHashMap();
                linkedHashMap.put("name", names); // 名称
                linkedHashMap.put("value", values); // 数量
                return linkedHashMap;
            }
        }
    }

    /**
     * 各个区今日旧改施工数
     */
    public void setConstructionOld(String initTime){
        ZdszBigscreenBo zdszBigscreenBo = new ZdszBigscreenBo();
        String time = getPreviousDay();
        if(initTime != null){
            time = initTime;
        }
        zdszBigscreenBo.setTime(time);
        Map map = new HashMap();
        map.put("time", time); // 创建时间
        List<Map> initMaps = new ArrayList<>();
        List<String> monthList = batchInitMonthList(null);
        for (String month: monthList) {
            String[] times = month.split("-");
            zdszBigscreenBo.setInfo("z_engineering_info_" + times[0] + "_" + times[1]); // z_engineering_info_2024_03
            zdszBigscreenBo.setNode("z_engineering_node_" + times[0] + "_" + times[1]); // z_engineering_node_2024_03
            List<Map> maps = bigscreenMapper.civiNumOld(zdszBigscreenBo); // xz7 1768475728581869569 有重复 需过滤
            initMaps = mapMergeMapById(initMaps, calculateMapData(maps));
        }
        map.put("json", mapToJson(initMaps)); // JSON数据
        bigscreenMapper.setConstructionOld(map);
    }
    private List<Map> calculateMapData(List<Map> maps){
        List<Map> mapList = new ArrayList<>();
        for (Map<String, Object> source: maps) {
            String sourceKey = source.get("key").toString();
            String sourceValue = "" + source.get("value");
            boolean isExist = false;
            for (Map<String, String> map: mapList) {
                String key = map.get("key");
                String id = map.get("id");
//                if(key != null ){
                if(sourceKey.equals(key) && sourceValue.equals(id)){
//                    Long value = Long.valueOf(""+map.get("value")) + 1L;
//                    map.put("value", value.toString());
                    isExist = true;
                    break;
                }
            }
            if(!isExist){
                Map map = new HashMap();
                map.put("id", sourceValue);
                map.put("key", sourceKey);
                map.put("value", "1");
                mapList.add(map);
            }
        }
        return mapList;
    }
    @Override
    public Map getConstructionOld(ZdszBigscreenBo zdszBigscreenBo){
//        batchInitData("2024-08-01");
        String time = zdszBigscreenBo.getTime();
        if(time == null){
            zdszBigscreenBo.setTime(getPreviousDay());
        }else if(time.equals(new SimpleDateFormat("yyyy-MM-dd").format(new Date()))){
            setConstructionOld(time);
        }
        Map<String, List<SysDictData>> sysDictMap = RedisUtils.getCacheMap("sys_dict");
        List<SysDictData> dictDataList = sysDictMap.get("district");
        clearTime(zdszBigscreenBo);
        List<Map> list = bigscreenMapper.getConstructionOld(zdszBigscreenBo);
        int size = list.size();
        switch (size){
            case 0:{
                List names = new ArrayList();
                List values = new ArrayList();
                for (SysDictData dictData: dictDataList) {
//                    names.add(dictData.getDictLabel());
                    if(dictData.getRemark().equals("门市房")){
                        continue;
                    }
                    names.add(dictData.getRemark());
                    values.add(0);
                }
                Map map = new LinkedHashMap();
                map.put("name", names); // 名称
                map.put("value", values); // 数量
                return map;
            }
            case 1:{
                List names = new ArrayList();
                List values = new ArrayList();
                Map map = list.get(0);
                String jsonStr = map.get("json").toString();
                JsonValue jsonValue = Json.parse(jsonStr);
                JsonObject jsonObject = jsonValue.asObject();
                for (SysDictData dictData: dictDataList) {
//                    names.add(dictData.getDictLabel());
                    if(dictData.getRemark().equals("门市房")){
                        continue;
                    }
                    names.add(dictData.getRemark());
                    Object value = jsonObject.get(dictData.getDictValue());
                    values.add(value == null ? 0 : Long.valueOf(value.toString()));
                }
                Map linkedHashMap = new LinkedHashMap();
                linkedHashMap.put("name", names); // 名称
                linkedHashMap.put("value", values); // 数量
                return linkedHashMap;
            }
            default:{
                List names = new ArrayList();
                List values = new ArrayList();
                for (SysDictData dictData: dictDataList) {
//                    names.add(dictData.getDictLabel());
                    if(dictData.getRemark().equals("门市房")){
                        continue;
                    }
                    names.add(dictData.getRemark());
                    Long longValue = 0L;
                    for (int i = 0; i < list.size(); i++) {
                        Map map = list.get(i);
                        String jsonStr = map.get("json").toString();
                        JsonValue jsonValue = Json.parse(jsonStr);
                        JsonObject jsonObject = jsonValue.asObject();
                        Object valueObj = jsonObject.get(dictData.getDictValue());
                        Long value = valueObj == null ? 0L : Long.valueOf(valueObj.toString());
                        longValue += value;
                    }
                    values.add(longValue);
                }
                Map linkedHashMap = new LinkedHashMap();
                linkedHashMap.put("name", names); // 名称
                linkedHashMap.put("value", values); // 数量
                return linkedHashMap;
            }
        }
    }

    String getPreviousDay(){
        // 获取当前日期
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(new Date());
        // 将日期减一天
        calendar.add(Calendar.DAY_OF_MONTH, -1);
        // 获取前一天的日期
        Date previousDay = calendar.getTime();
        return new SimpleDateFormat("yyyy-MM-dd").format(previousDay);
    }
    void clearTime(ZdszBigscreenBo zdszBigscreenBo){
        String beginTime = zdszBigscreenBo.getBeginTime();
        String endTime = zdszBigscreenBo.getEndTime();
        if((beginTime != null && !beginTime.equals("")) || (endTime != null && !endTime.equals(""))){
            zdszBigscreenBo.setTime(null);
        }
    }
    String mapToJson(List<Map> maps){
        String start = "{";
        for (int i = 0; i < maps.size(); i++) {
            Map data = maps.get(i);
            Object keyObj = data.get("key");
            if(keyObj == null){
                continue;
            }
            String key = keyObj.toString();
            Long value = Long.valueOf(data.get("value").toString());
            start = start + "\"" + key + "\":"+value+",";
        }
        if(maps.size() > 0 && start.length() > 1){
            start = start.substring(0, start.length() - 1);
        }
        String end= "}";
        String json= start + end;
        return json;
    }
    List<Map> mapMergeMap(List<Map> destinations, List<Map> maps){
        for (int i = 0; i < maps.size(); i++) {
            boolean isExist = false;
            for (int j = 0; j < destinations.size(); j++) {
                Map destination = destinations.get(j);
                Map map = maps.get(i);
                Object keyObj = map.get("key");
                if(keyObj == null){
                    continue;
                }
                if(keyObj.equals(destination.get("key"))){
                    isExist = true;
                    Long value = Long.valueOf(destination.get("value").toString()) + Long.valueOf(map.get("value").toString());
                    destination.put("value", value);
                    break;
                }
            }
            if(!isExist){
                destinations.add(maps.get(i));
            }
        }
        return destinations;
    }
    List<Map> mapMergeMapById(List<Map> destinations, List<Map> maps){
        for (int i = 0; i < maps.size(); i++) {
            boolean isExist = false;
            for (int j = 0; j < destinations.size(); j++) {
                Map destination = destinations.get(j);
                Map map = maps.get(i);
                Object keyObj = map.get("key");
                if(keyObj == null || destination.get("id") == null){
                    continue;
                }
                if(keyObj.equals(destination.get("key"))){
                    if(destination.get("id").equals(map.get("id"))){
                        isExist = true;
                        break;
                    }else {
                        isExist = true;
                        Long value = Long.valueOf(destination.get("value").toString()) + Long.valueOf(map.get("value").toString());
                        destination.put("value", value);
                        break;
                    }
                }
            }
            if(!isExist){
                destinations.add(maps.get(i));
            }
        }
        return destinations;
    }

    @Override
    public void bigscreenAutoQueryYesterdayData(String initTime){
        setConstructionProgress(initTime); // 施工进度统计
        setProjectStatus(initTime); // 工程状态统计
        setCountEngineering(initTime); // 今日施工数
        setCountPerson(initTime); // 今日使用人数
        setConstructionMap(initTime); // 地图施工数据分布
        setConstructionOld(initTime); // 各个区今日旧改施工数
        setConstructionNew(initTime); // 各个区今日施工数
    }

    @Override
    public void batchInitData(String startTime){
        List<String> times = batchInitDateList(startTime);
        for (String time: times) {
            System.out.println("time=" + time);
            bigscreenAutoQueryYesterdayData(time);
        }
    }

    public List batchInitMonthList(String startTime){
        if(startTime == null){
            startTime = "2024-03";
        }
        Date today = new Date();
        List list = new ArrayList();
        list.add(startTime);
        while (!startTime.equals(new SimpleDateFormat("yyyy-MM").format(today))){
            list.add(getNextMonth(startTime));
            startTime = getNextMonth(startTime);
        }
        return list;
    }
    public String getNextMonth(String date){
        Calendar calendar = Calendar.getInstance();
        try {
            calendar.setTime(new SimpleDateFormat("yyyy-MM").parse(date));
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
        // 将日期加一个月
        calendar.add(Calendar.MONTH, 1);
        // 获取下一月的日期
        Date nextMonth = calendar.getTime();
        return new SimpleDateFormat("yyyy-MM").format(nextMonth);
    }
    public List batchInitDateList(String startTime){
        Date today = new Date();
        List list = new ArrayList();
        list.add(startTime);
        while (!startTime.equals(new SimpleDateFormat("yyyy-MM-dd").format(today))){
            list.add(getNextDay(startTime));
            startTime = getNextDay(startTime);
        }
        return list;
    }
    public String getNextDay(String date){
        Calendar calendar = Calendar.getInstance();
        try {
            calendar.setTime(new SimpleDateFormat("yyyy-MM-dd").parse(date));
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
        // 将日期加一天
        calendar.add(Calendar.DAY_OF_MONTH, 1);
        // 获取后一天的日期
        Date nextDay = calendar.getTime();
        return new SimpleDateFormat("yyyy-MM-dd").format(nextDay);
    }
}
